var pToggle = true;
var pColorOneIndex;
var pColorTwoIndex;
var pTypeIndex;
var pColorOne;
var pColorTwo;
var pType;

function initOptions() {
   //alert('test');
   hideOptions();
   
   loadOptions();
   
   if (pColorOne == undefined) {
	   pColorOne = [237, 28, 36];
	   pColorTwo = [255, 255, 255];
	   pType = "bars";
	   
	   pColorOneIndex = 0;
	   pColorTwoIndex = 8;
	   pTypeIndex = 0;
	   
	   saveOptions();
   }
   
   //Set dropdowns to stored states
   
   $("#color_one_selector").prop('selectedIndex', pColorOneIndex);
   $("#color_two_selector").prop('selectedIndex', pColorTwoIndex);
   $("#type_selector").prop('selectedIndex', pTypeIndex);
}

function toggleOptions() {
   if (pToggle) {
      showOptions();
   }else{
      hideOptions();
   }
   
   pToggle = !pToggle;
}

function hideOptions() {
   $("#options_container").fadeOut(0);
}

function showOptions() {
   $("#options_container").fadeIn('slow');
}

function setType(dropdown) {
   pTypeIndex  = dropdown.selectedIndex;
   var number = dropdown.options[pTypeIndex].value;
   
   switch(number) {
      case "0":
      pType = "bars";
      break;
      
      case "1":
      pType = "pie";
      break;
      
      case "2":
      pType = "dots";
      break;
      
      case "3":
      pType = "squares";
      break;
   }
   
   saveOptions();
}

function getType() {
   return pType;
}

function setColorOne(dropdown) {
   pColorOneIndex = dropdown.selectedIndex;
   var number = dropdown.options[pColorOneIndex].value;
   
   switch(number) {
      case "0":
      pColorOne = [237, 28, 36];
      break;
      
      case "1":
      pColorOne = [247, 148, 29];
      break;
      
      case "2":
      pColorOne = [255, 247, 153];
      break;
      
      case "3":
      pColorOne = [0, 196, 14];
      break;
      
      case "4":
      pColorOne = [27, 153, 236];
      break;
      
      case "5":
      pColorOne = [133, 96, 168];
      break;
      
      case "6":
      pColorOne = [0, 0, 0];
      break;
      
      case "7":
      pColorOne = [150, 150, 150];
      break;
      
      case "8":
      pColorOne = [255, 255, 255];
      break;
   }
   
   saveOptions();
   changeNumeratorColor();
}

function getColorOne() {
   return pColorOne;
}

function setColorTwo(dropdown) {
   pColorTwoIndex  = dropdown.selectedIndex;
   var number = dropdown.options[pColorTwoIndex].value;
   
   switch(number) {
      case "0":
      pColorTwo = [237, 28, 36];
      break;
      
      case "1":
      pColorTwo = [247, 148, 29];
      break;
      
      case "2":
      pColorTwo = [255, 247, 153];
      break;
      
      case "3":
      pColorTwo = [0, 196, 14];
      break;
      
      case "4":
      pColorTwo = [27, 153, 236];
      break;
      
      case "5":
      pColorTwo = [133, 96, 168];
      break;
      
      case "6":
      pColorTwo = [0, 0, 0];
      break;
      
      case "7":
      pColorTwo = [150, 150, 150];
      break;
      
      case "8":
      pColorTwo = [255, 255, 255];
      break;
   }
   
   saveOptions();
   changeDenominatorColor();
}

function getColorTwo() {
   return pColorTwo;
}

function loadOptions() {
	pColorOneIndex = NB.persist.load("pColorOneIndex");
	pColorTwoIndex = NB.persist.load("pColorTwoIndex");
	pTypeIndex = NB.persist.load("pTypeIndex");
	var color_one = NB.persist.load("pColorOne");
	var color_two = NB.persist.load("pColorTwo");
	var type = NB.persist.load("pType");
	
	//Looks like NB is adding quotes to strings here as well. This should be a workaround that doesn't break when they fix the bug.
	if (type != undefined) {
		if (type.indexOf("bars") > -1) {
			pType = "bars";
		}
	
		if (type.indexOf("pie") > -1) {
			pType = "pie";
		}
	
		if (type.indexOf("dots") > -1) {
			pType = "dots";
		}
	
		if (type.indexOf("squares") > -1) {
			pType = "squares";
		}
	}
	
	//NB persist is storing with extra quotes. Jumping some hoops here - because storing as array doesn't work, either...
	if (color_one != undefined) {
		color_one = color_one.split("\"").join();
		var temp_array = color_one.split(",");
		//alert("temp_array: " + temp_array);
		var i;
		
		pColorOne = [];
		for (i=0; i<temp_array.length; i++) {
			pColorOne.push(parseInt(temp_array[i]));
		}
		
		//Working around the NB bug
		if (pColorOne.length == 5) {
			//Remove the extra garbage commas
			pColorOne.pop();
			pColorOne.shift();
		}
		
		color_two = color_two.split("\"").join();
		temp_array = color_two.split(",");
		
		pColorTwo = [];
		for (i=0; i<temp_array.length; i++) {
			pColorTwo.push(parseInt(temp_array[i]));
		}
		
		//Working around the NB bug
		if (pColorTwo.length == 5) {
			//Remove the extra garbage commas
			pColorTwo.pop();
			pColorTwo.shift();
		}
	}
	
	/*alert("pColorOneIndex: "+pColorOneIndex);
	alert("pColorTwoIndex: "+pColorTwoIndex);
	alert("pTypeIndex: "+pTypeIndex);
	alert("pColorOne: "+pColorOne);
	alert("pColorTwo: "+pColorTwo);
	alert("pType: "+pType);*/
}

function saveOptions() {
	NB.persist.remove("pColorOneIndex");
	NB.persist.save("pColorOneIndex", pColorOneIndex);
	
	NB.persist.remove("pColorTwoIndex");
	NB.persist.save("pColorTwoIndex", pColorTwoIndex);
	
	NB.persist.remove("pTypeIndex");
	NB.persist.save("pTypeIndex", pTypeIndex);
	
	var color_one_string = pColorOne.join();
	NB.persist.remove("pColorOne");
	NB.persist.save("pColorOne", color_one_string);
	
	var color_two_string = pColorTwo.join();
	NB.persist.remove("pColorTwo");
	NB.persist.save("pColorTwo", color_two_string);
	
	NB.persist.remove("pType");
	NB.persist.save("pType", pType);
}
 	
