var pToggle = true;
var pNumeratorObjects;
var pDenominatorObjects;
var pStrokeColor;

var pNumerator;
var pDenominator;


function initVisualFractions() {
   pNumeratorObjects = [];
   pDenominatorObjects = [];
   pStrokeColor = [70, 70, 70];
   
   NB.helpers.handwritable($("#writing_one"), function(text, obj) {
       //var insert = evaluateWriting(text);
	   //alert("write");
	   var insert = String(text);
	   if (insert.length > 2) {
		   insert = "99";
		   text = 99;
	   }
	   
       pNumerator = text;
       $("#writing_one").text(insert); 
       obj.deleteObject();
       //drawFraction();
   }, {timeToRecognize: 3, wantsNumbers: true});
   
   NB.helpers.handwritable($("#writing_two"), function(text, obj) {
       //var insert = evaluateWriting(text);
	   var insert = String(text);
	   if (insert.length > 2) {
		   insert = "99";
		   text = 99;
	   }
       pDenominator = text;
       $("#writing_two").text(insert); 
       obj.deleteObject();
       //drawFraction();
   }, {timeToRecognize: 3, wantsNumbers: true});
   
   NB.addObserver('inkingEvent', hidePrompts);
}

function hidePrompts(obj){
	$("#writing_prompt_canvas_one").fadeOut(0);
	$("#writing_prompt_canvas_two").fadeOut(0);
}

function evaluateWriting(text) {
    // If recognition comes back with letters that resemble numbers, switch them
    var return_val = text;
    
    if(text.indexOf("I") != -1) return_val = text.split("I").join("1");
    if(text.indexOf("l") != -1) return_val = text.split("l").join("1");
    if(text.indexOf("o") != -1) return_val = text.split("o").join("0");
    if(text.indexOf("O") != -1) return_val = text.split("O").join("0");
    if(text.indexOf("Z") != -1) return_val = text.split("Z").join("2");
    if(text.indexOf("z") != -1) return_val = text.split("z").join("2");
    if(text.indexOf("q") != -1) return_val = text.split("q").join("9");
    if(text.indexOf("g") != -1) return_val = text.split("g").join("9");
    if(text.indexOf("G") != -1) return_val = text.split("G").join("6");
    if(text.indexOf("s") != -1) return_val = text.split("s").join("5");
    if(text.indexOf("S") != -1) return_val = text.split("S").join("5");
    if(text.indexOf("Y") != -1) return_val = text.split("Y").join("4");
    if(text.indexOf("y") != -1) return_val = text.split("y").join("4");
    
    return return_val;
}

function toggleInfo() {
   if (pToggle) {
      showInstructions();
   }else{
      hideInstructions();
   }
   
   pToggle = !pToggle;
}

function showInstructions() {
   $("#instructions").fadeIn('slow');
}

function hideInstructions() {
   $("#instructions").fadeOut('slow');
}

function drawFraction(){
   //alert("pDenominator: " + pDenominator);

   pNumeratorObjects = [];
   pDenominatorObjects = [];
   
   var type = getType();
   //alert("type: " + type);
   
   if (isNaN(pNumerator)) {
      alert('Please enter a numerator.');
      return;
   }
   
   if (isNaN(pDenominator)) {
      alert('Please enter a denominator.');
      return;
   }
   
   if (pDenominator == 0) {
      alert('The denominator can not be zero.');
      return;
   }
   
   if (pDenominator < pNumerator) {
      alert('The denominator must be greater than the numerator.');
      return;
   }
   
   switch(type) {
      case "bars":
      drawBars(pNumerator, pDenominator);
      break;
      
      case "pie":
      drawPie(pNumerator, pDenominator);
      break;
      
      case "dots":
      drawDots(pNumerator, pDenominator);
      break;
      
      case "squares":
      drawSquares(pNumerator, pDenominator);
      break;
   }
}

function drawPie(numerator, denominator){
    var i;
    var new_obj;
    var radius = 100.0;
    var obj_id;
    var group = [];
    var buffer = 10.0;
    var start_x = radius*2 + buffer;
    var start_y = radius + buffer;
    var center_x = radius + buffer;
    var center_y = radius + buffer; 
    
    var start_degrees = 360.0/denominator;
    //var degrees = start_degrees;
    var start_rads = start_degrees*Math.PI/180;
    var rads = start_rads;
    
    var end_x;
    var end_y;

    for (i=0; i<denominator; i++) {
        //(x?,y?)=(x+dcosα,y+dsinα)
        //end_x = center_y + radius*Math.cos(degrees);
        //end_y = center_y + radius*Math.sin(degrees);
        
        end_x = center_x + radius*Math.cos(rads);
        end_y = center_y + radius*Math.sin(rads);
        //alert('start_x:' + start_x + ', start_y:' + start_y + ', end_x:' + end_x + ', end_y:' + end_y + 'rads:' + rads);
		
		/*new_obj = drawPieArc(start_x, start_y, end_x, end_y, radius, radius);
        new_obj.fill.color = getColorTwo();
        new_obj.stroke.color = pStrokeColor;
      
        obj_id = NB.addObject(new_obj);
		pDenominatorObjects.push(obj_id);
        group.push(obj_id);*/
    
        new_obj = drawPieWedge(center_x, center_y, start_x, start_y, end_x, end_y, radius, start_rads, rads);
        new_obj.fill.color = getColorTwo();
        new_obj.stroke.color = pStrokeColor;
      
        obj_id = NB.addObject(new_obj);
      
        pDenominatorObjects.push(obj_id);
        group.push(obj_id);
        
        //degrees += start_degrees;
        rads += start_rads;
        
        start_x = end_x;
        start_y = end_y;
    }

    for (i=0; i<numerator; i++) {
        //(x?,y?)=(x+dcosα,y+dsinα)
        //end_x = center_y + radius*Math.cos(degrees);
        //end_y = center_y + radius*Math.sin(degrees);
        
        end_x = center_x + radius*Math.cos(rads);
        end_y = center_y + radius*Math.sin(rads);
        //alert('start_x:' + start_x + ', start_y:' + start_y + ', end_x:' + end_x + ', end_y:' + end_y + 'rads:' + rads);
    
        /*new_obj = drawPieArc(start_x, start_y, end_x, end_y, radius, radius);
        new_obj.fill.color = getColorOne();
        new_obj.stroke.color = pStrokeColor;
      
        obj_id = NB.addObject(new_obj);
		
		pNumeratorObjects.push(obj_id);
        group.push(obj_id);*/
		
		new_obj = drawPieWedge(center_x, center_y, start_x, start_y, end_x, end_y, radius, start_rads, rads);
        new_obj.fill.color = getColorOne();
        new_obj.stroke.color = pStrokeColor;
      
        obj_id = NB.addObject(new_obj);
      
        pNumeratorObjects.push(obj_id);
        group.push(obj_id);
        
        //degrees += start_degrees;
        rads += start_rads;
        
        start_x = end_x;
        start_y = end_y;
    }
    
    NB.page.groupObjects(group); 
}

/*function drawPieArc(start_x, start_y, end_x, end_y, x_radius, y_radius) {
    //var arc_obj = NB.objectPrototype.curvedLine(start_x, start_y, end_x, end_y, x_radius, y_radius, true, true, {});
	
	new_obj = NB.objectPrototype.shape("arc");
       
    new_obj.width = end_x-start_x;
    new_obj.height = end_y-start_y;
    new_obj.x = start_x;
    new_obj.y = start_y;
	
	return arc_obj;
}*/

function drawPieWedge(center_x, center_y, start_x, start_y, end_x, end_y, radius, start_rads, rads) {
    
    var slice_obj = NB.objectPrototype.shape();
	var i;
	
	//Until they tell me how to draw an arc, going to calculate steps and draw straight line segments
	var steps = [];
	var distance = Math.sqrt(Math.abs(end_x - start_x) + Math.abs(end_y - start_y));
	var temp_x;
	var temp_y;
	var temp_rads = rads;
	
	/*
	while (temp_rads < start_rads + rads) {
		temp_rads += Math.PI/180;
		temp_x = center_x + radius*Math.cos(temp_rads);
        temp_y = center_y + radius*Math.sin(temp_rads);
		steps.push({x:temp_x, y:temp_y});
	}*/
	
	while (temp_rads > rads - start_rads) {
		temp_rads -= Math.PI/180;
		temp_x = center_x + radius*Math.cos(temp_rads);
        temp_y = center_y + radius*Math.sin(temp_rads);
		steps.push({x:temp_x, y:temp_y});
	}
	
	//steps.reverse();
    
    slice_obj.moveTo(start_x, start_y);
    slice_obj.lineTo(center_x, center_y);
    slice_obj.lineTo(end_x, end_y);
	
	for (i=0; i<steps.length; i++) {
		slice_obj.lineTo(steps[i].x, steps[i].y);
	}
	
    slice_obj.lineTo(start_x, start_y);
    //slice_obj.curvedLineTo(start_x, start_y, 30, 30);
    
    slice_obj.closeLine();
    
    return slice_obj;
}

function drawBars(numerator, denominator){

   //alert("bars");
   var i;
   var new_obj;
   var start_x = 10;
   var temp_x = start_x;
   var temp_y = 10;
   var dimension = 44;
   var limit = 10; //Limit of shapes in a row;
   var buffer = 0;
   var obj_id;
   var group = [];
   
   var counter = 1;
   
   for (i=0; i<numerator; i++) {
      new_obj = NB.objectPrototype.shape("rectangle");
       
      new_obj.width = dimension*1.7;
      new_obj.height = dimension;
      new_obj.x = temp_x;
      new_obj.y = temp_y;
	  
	  var test = getColorOne();
	  /*alert("length: "+test.length);
	  alert("0: "+test[0]);
	  alert("1: "+test[1]);
	  alert("2: "+test[2]);*/
	  
      new_obj.fill.color = getColorOne();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += new_obj.width + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += new_obj.height + buffer;
	  }
      
      pNumeratorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   for (i=0; i<(denominator - numerator); i++) {
      new_obj = NB.objectPrototype.shape("rectangle");
       
      new_obj.width = dimension*1.7;
      new_obj.height = dimension;
      new_obj.x = temp_x;
      new_obj.y = temp_y;
      new_obj.fill.color = getColorTwo();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += new_obj.width + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += new_obj.height + buffer;
	  }
      
      pDenominatorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   NB.page.groupObjects(group);

}

function drawDots(numerator, denominator){
   //Check this
   var i;
   var new_obj;
   var start_x = 10;
   var temp_x = start_x;
   var temp_y = 10;
   var radius = 32.0;
   var limit = 10; //Limit of shapes in a row;
   var buffer = 5;
   var obj_id;
   var group = [];
   
   var counter = 1;
   
   for (i=0; i<numerator; i++) {
      new_obj = NB.objectPrototype.ellipse(radius, radius, radius, radius);
       
      new_obj.x = temp_x;
      new_obj.y = temp_y;
      new_obj.fill.color = getColorOne();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += radius*2 + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += radius*2 + buffer;
	  }
      
      pNumeratorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   for (i=0; i<(denominator - numerator); i++) {
      new_obj = NB.objectPrototype.ellipse(radius, radius, radius, radius);
       
      new_obj.x = temp_x;
      new_obj.y = temp_y;
      new_obj.fill.color = getColorTwo();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += radius*2 + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += radius*2 + buffer;
	  }
      
      pDenominatorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   NB.page.groupObjects(group);
   
}

function drawSquares(numerator, denominator){

   var i;
   var new_obj;
   var start_x = 10;
   var temp_x = start_x;
   var temp_y = 10;
   var dimension = 64;
   var limit = 10; //Limit of shapes in a row;
   var buffer = 5;
   var obj_id;
   var group = [];
   
   var counter = 1;
   
   for (i=0; i<numerator; i++) {
      new_obj = NB.objectPrototype.shape("rectangle");
       
      new_obj.width = dimension;
      new_obj.height = dimension;
      new_obj.x = temp_x;
      new_obj.y = temp_y;
      new_obj.fill.color = getColorOne();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += new_obj.width + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += dimension + buffer;
	  }
      
      pNumeratorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   for (i=0; i<(denominator - numerator); i++) {
      new_obj = NB.objectPrototype.shape("rectangle");
       
      new_obj.width = dimension;
      new_obj.height = dimension;
      new_obj.x = temp_x;
      new_obj.y = temp_y;
      new_obj.fill.color = getColorTwo();
      new_obj.stroke.color = pStrokeColor;
      
      obj_id = NB.addObject(new_obj);
      temp_x += new_obj.width + buffer;
	  
	  if (counter % limit == 0) {
		  temp_x = start_x;
		  temp_y += dimension + buffer;
	  }
      
      pDenominatorObjects.push(obj_id);
      group.push(obj_id);
	  
	  counter++;
   }
   
   NB.page.groupObjects(group);
    
}

function changeNumeratorColor(){
   var i;
   
   for (i=0; i<pNumeratorObjects.length; i++) {
      pNumeratorObjects[i].fill.color = getColorOne();
      pNumeratorObjects[i].update();
   }
}

function changeDenominatorColor(){
   var i;

   for (i=0; i<pDenominatorObjects.length; i++) {
      pDenominatorObjects[i].fill.color = getColorTwo();
      pDenominatorObjects[i].update();
   }
}


